#ifndef MANIPULATOR_H_
#define MANIPULATOR_H_

#include <set>
#include <vector>
#include "libr2c2/object.h"
#include "tool.h"

class Selection;

class Manipulator: public Tool
{
protected:
	struct MObject
	{
		R2C2::Object *object;
		R2C2::Vector original_position;
		R2C2::Angle original_rotation;

		MObject(R2C2::Object *);
	};

public:
	sigc::signal<void, bool> signal_done;

protected:
	typedef std::vector<MObject> ObjectArray;

	ObjectArray objects;
	R2C2::Vector center;

public:
	Manipulator(Designer &, Msp::Input::Keyboard &, Msp::Input::Mouse &, const std::set<R2C2::Object *> &);
	virtual ~Manipulator();

private:
	virtual void finish();
};

#endif
