#ifndef ROUTEBAR_H_
#define ROUTEBAR_H_

#include <msp/gltk/dropdown.h>
#include "toolbar.h"

class Routebar: public Toolbar, public sigc::trackable
{
private:
	Designer &designer;
	Msp::GLtk::FunctionListData<R2C2::Route *> routes;
	Msp::GLtk::Dropdown *drp_routes;

public:
	Routebar(Designer &);

private:
	void route_selected(unsigned);
	void delete_route_clicked();
	void track_chain_added(R2C2::TrackChain &);
	void track_chain_removed(R2C2::TrackChain &);
	void route_name_changed(const std::string &, R2C2::Route *);
};

#endif
