#include <msp/gltk/row.h>
#include "toolbar.h"

using namespace std;
using namespace Msp;

Toolbar::Toolbar(const string &name):
	expanded(true)
{
	set_focusable(false);
	set_layout(new GLtk::Layout);
	GLtk::Row row(*layout);
	layout->set_margin(GLtk::Sides(6, 10));
	layout->set_column_spacing(10);

	add(*(lbl_title = new GLtk::Label(name)));

	add(*(btn_expand = new GLtk::Button));
	btn_expand->set_style("arrow_left");
	btn_expand->set_tooltip("Collapse toolbar");
	btn_expand->signal_clicked.connect(sigc::mem_fun(this, &Toolbar::expand_clicked));

	add(*(pnl_content = new GLtk::Panel));
	pnl_content->set_style("group");
	GLtk::Layout *content_layout = new GLtk::Layout;
	// XXX This needs to get deleted somehow
	new GLtk::Row(*content_layout);
	pnl_content->set_layout(content_layout);
	content_layout->set_margin(0);
}

void Toolbar::expand(bool e)
{
	expanded = e;
	btn_expand->set_style(expanded ? "arrow_left" : "arrow_right");
	btn_expand->set_tooltip(expanded ? "Collapse toolbar" : "Expand toolbar");
	pnl_content->set_visible(expanded);
	signal_autosize_changed.emit();

	signal_expanded.emit(expanded);
}

void Toolbar::expand_clicked()
{
	expand(!expanded);
}
