#include <msp/strings/utils.h>
#include "articlenumber.h"

using namespace std;
using namespace Msp;

namespace R2C2 {

ArticleNumber::ArticleNumber(const string &a):
	article(a)
{ }

ArticleNumber::ArticleNumber(const string &v, const string &a, const string &p):
	vendor(v),
	article(a),
	part(p)
{ }

string ArticleNumber::str() const
{
	string result;
	if(!vendor.empty())
	{
		result += vendor;
		result += ' ';
	}
	result += article;
	if(!part.empty())
	{
		result += '-';
		result += part;
	}

	return result;
}


ArticleNumber::Loader::Loader(ArticleNumber &an):
	DataFile::ObjectLoader<ArticleNumber>(an)
{
	add("vendor", &ArticleNumber::vendor);
	add("article", &ArticleNumber::article);
	add("part", &ArticleNumber::part);
}


void operator<<(LexicalConverter &conv, const ArticleNumber &art_nr)
{
	conv.result(art_nr.str());
}

} // namespace R2C2
